<?php

/**
 * Viper2 Framework
 *
 * @author fish <fish@archa.cz>
 * @package Viper2
 * @version 0.1
 *
 */
/**
 * Message box
 * @package Msgbox
 * @author fish <fish@archa.cz>
 * @version 0.1
 *
 *
 */

class Msgbox extends Viper2Plugin {
  
  protected $messages = array();
  
  function __construct() {
    $this->pluginName = "Msgbox";
    // $this->pluginUri = "/--msgbox/";
    $this->setPriority(-100000);
    
    $this->cssLink = "/css/msgbox.css";
    $this->cssStamp = "201110061414";
    
  }

  public function actionGlobal() {
    // pre_print($_SESSION["msgbox"]);
    if (isset($_SESSION) && isset($_SESSION["msgbox"])) {
      if (is_array($_SESSION["msgbox"])) {
        foreach ($_SESSION["msgbox"] as $prior=>$messageGrp) {
          foreach ($messageGrp as $message) {
            $this->add($message["text"], $message["type"], $message["header"], $prior);
          }
        }
      } else {
        $this->add($_SESSION["msgbox"]);
      }
      unset($_SESSION["msgbox"]);
    }
    
    if (Viper2::$useSmarty) {
      Viper2::$smarty->register_function("msgbox", array($this,"show"));
    }
  }

  public function renderGlobal($params, &$s) {
    if (Viper2::$useSmarty) {
      ksort($this->messages);
      foreach ($this->messages as $prior=>$messageGrp) {
        foreach ($messageGrp as $message) {
          $this->show($message, $s);
        }
      }
    }
  }
  
  public function add($text, $type="err", $header="", $prior=0) {
    $this->messages[$prior][] = array("text"  =>  $text,
                                      "type"  =>  $type,
                                      "header" =>  $header!=""?$header:($type=="err"?_("upozornění"):_("informace")),
                                      );
    
  }

  public function addOk($text, $header="", $prior=0) {
    $this->add($text, "ok", $header, $prior);
  }
  
  public function send($text, $type="err", $header="", $prior=0) {
    $_SESSION["msgbox"][$prior][] = array("text"  =>  $text,
                                      "type"  =>  $type,
                                      "header" =>  $header!=""?$header:($type=="err"?_("upozornění"):_("informace")),
                                      );
    
  }

  public function sendOk($text, $header="", $prior=0) {
    $this->send($text, "ok", $header, $prior);
  }


  public function put($text, $type="err", $header="", $prior=0) {
    $this->show(array("text"  =>  $text,
                                      "type"  =>  $type,
                                      "header" =>  $header!=""?$header:($type=="err"?_("upozornění"):_("informace")),
                                      ),
                Viper2::$smarty);
    
  }

  public function putOk($text, $header="", $prior=0) {
    $this->put($text, "ok", $header, $prior);
  }

  public function show($params, &$s) {
    $this->useCSS();
    $params["bs_type"] = "-default";
    if ($params["type"] === "err" ) {
      $params["bs_type"] = "-danger";
    }
    if ($params["type"] === "ok" ) {
      $params["bs_type"] = "-success";
    }
    $s->assign("errMessage", $params);
    $s->display("msgbox.tpl");
  }
  
}
?>