<?php
/**
 * ukladani session do mysql
 *
 * @author fish <fish@archa.cz>
 * @package mysql_session
 * @version 0.1
 *
 */
/**
 * zpracovani session
 * @package mysql_session
 *
 */
class mysql_session {
  /**
   * variable $dbh
   * @private object handle databaze
   */
  private $dbh=NULL;
  /**
   * variable $maxlifetime
   * @private integer zivotnost session
   */
  private $maxlifetime=3600;
  /**
   * variable $security
   * @public string doplneni user agenta v hashi
   */
  public $security="9Cex7dI0TwEDDmNH";


  // {{{ constructor
	/**
	 * Constructor
	 *
	 * @param object $dbh handle databaze
	 */
	function __construct($dbh){
    $this->dbh=$dbh;
	
    $this->maxlifetime = ini_get("session.gc_maxlifetime");

    session_set_save_handler(
        array(&$this, 'open'),
        array(&$this, 'close'),
        array(&$this, 'read'),
        array(&$this, 'write'),
        array(&$this, 'destroy'),
        array(&$this, 'gc')
    );
	}
  // }}} constructor

  /**
   *  Deletes all data related to the session
   *
   */
  function stop(){
    $this->regenerate_id();
    session_unset();
    session_destroy();
  }

  /**
   *  Regenerates the session id.
   *
   */
  function regenerate_id(){
    $oid=session_id();
    session_regenerate_id();
    $this->destroy($oid);
  }

  /**
   *  Custom open() function
   *
   */
  function open($save_path, $session_name){
    return(TRUE);
  }

  /**
   *  Custom close() function
   *
   */
  function close(){
    return(TRUE);
  }

  /**
   *  Custom read() function
   *
   */
  function read($session_id){
    $query ="SELECT session_data FROM session_data ";
    $query.="WHERE session_id='".mysql_real_escape_string($session_id)."' ";
    $query.="AND http_user_agent='".mysql_real_escape_string(md5((isset($_SERVER["HTTP_USER_AGENT"])?$_SERVER["HTTP_USER_AGENT"]:'unknown').$this->security))."' ";
    $query.="AND session_expire>'".time()."' ";
    $query.="LIMIT 1 ";
//     echo $query;
    
    if($res=@mysql_query($query,$this->dbh)){
      if($row=@mysql_fetch_assoc($res)){
        return($row["session_data"]);
      }
    } else {
      echo mysql_error();
    }
    return("");
  }

  /**
   *  Custom write() function
   *
   */
  function write($session_id, $session_data){
    $query ="INSERT INTO session_data(session_id,http_user_agent,session_data,session_expire) ";
    $query.="VALUES('".mysql_real_escape_string($session_id)."','".mysql_real_escape_string(md5((isset($_SERVER["HTTP_USER_AGENT"])?$_SERVER["HTTP_USER_AGENT"]:'unknown').$this->security))."','".mysql_real_escape_string($session_data)."','".mysql_real_escape_string(time()+$this->maxlifetime)."') ";
    $query.="ON DUPLICATE KEY UPDATE session_data = '".mysql_real_escape_string($session_data)."', ";
    $query.="http_user_agent = '".mysql_real_escape_string(md5((isset($_SERVER["HTTP_USER_AGENT"])?$_SERVER["HTTP_USER_AGENT"]:'unknown').$this->security))."', ";
    $query.="session_expire = '".mysql_real_escape_string(time() + $this->maxlifetime)."' ";

    if (@mysql_query($query,$this->dbh)){
      if (@mysql_affected_rows($this->dbh)>1) {
        return(TRUE);
      } else {
        return("");
      }
    } else {
      echo mysql_error();
    }
    return(FALSE);
  }

  /**
   *  Custom destroy() function
   *
   */
  function destroy($session_id)  {
    $query ="DELETE FROM session_data ";
    $query.="WHERE session_id='".mysql_real_escape_string($session_id)."' ";

    $res=@mysql_query($query,$this->dbh);

    if (@mysql_affected_rows($this->dbh)){
     return(TRUE);
    }
    return(FALSE);
  }

  /**
   *  Custom gc() function (garbage collector)
   *
   */
  function gc($maxlifetime){
    $query ="DELETE FROM session_data ";
    $query.="WHERE session_expire < '".mysql_real_escape_string(time())."' LIMIT 100 ";
    return(@mysql_query($query,$this->dbh));
  }

}
?>
